###########################################################
#
#    Quotes 1.2 tcl for eggdrop (21/01/2005)
#    by lnx85 at #lnxlabs on SimosNap IRC Network (irc.simosnap.com)
#    E-mail: lnx85@lnxlabs.it
#
#    per attivare lo script  necessario impostare il flag +quotes
#    al canale (.chanset #chan +quotes)
#
#    per attivare i quotes globali su un chan impostare il flag +globalquotes
#    al canale (.chanset #chan +globalquotes)
#
#    I comandi:
#    !delquote - !addglobalquote - !delglobalquote
#    possono essere utilizzati solamente dagli owner
#
#    Nota Bene:
#    La directory specificata in quotes(dir) deve esistere
#
###########################################################

### GLOBALS ###
set quotes(dir) "data/quote/quotes"
set quotes(link) "http://quotes.simosnap.com/?chan="
set quotes(exclude) {
	#mnt
}
### END GLOBALS ###

### FLAGS ###
setudef flag quotes
setudef flag globalquotes
setudef flag oponlyquotes
### END FLAGS###

### BINDS ###
bind pub - !quote quotes:pub:quote
bind pub - !quotestats quotes:pub:stats
bind pub - !quotelink quotes:pub:link

bind pub - !addquote quotes:pub:add
bind pub - !delquote quotes:pub:del

bind pub n !addglobalquote quotes:pub:addglobal
bind pub n !delglobalquote quotes:pub:delglobal

bind dcc n quote quotes:dcc
### END BINDS ###

### PROCS ###
proc quotes:dcc { handle idx text } {
	switch  -- [ string tolower [ lindex [ split $text ] 0 ] ] {
		restore {
			set chan [ lindex [ split $text ] 1 ]
			if { [ validchan $chan ] } {
				putdcc $idx "Ripristino dei quotes per il canale $chan in corso..."
				set num [ quotes:restore $chan ]
				putdcc $idx "Ripristino effettuato. Quotes ripristinati: $num"
			}
		}
	}
}

proc quotes:pub:add { nick host handle chan text } {
	if { [ lsearch -exact [ channel info $chan ] "+quotes" ] == -1 } { return }
	if { $text != "" } {
		if { [ isop $nick $chan ] | [ ishalfop $nick $chan ] | [ isvoice $nick $chan ]} {
			quotes:add $nick $host $chan $text
			# exec /home/bot/quote/scripts/send.sh
			putserv "NOTICE $nick :Quote Aggiunta !"
		}
	} else {
		putserv "NOTICE $nick :\002Utilizzo:\002 !addquote <testo>"
	}
}

proc quotes:pub:del { nick host handle chan text } {
	if { [ lsearch -exact [ channel info $chan ] "+quotes" ] == -1 } { return }
	if { $text != "" } {
		if { [ isop $nick $chan ] } {
			quotes:del $nick $host $chan $text
			putserv "NOTICE $nick :Quote Eliminata !"
		}
	} else {
		putserv "NOTICE $nick :\002Utilizzo:\002 !delquote <testo>"
	}
}

proc quotes:pub:quote { nick host handle chan text } {
	if { [ lsearch -exact [ channel info $chan ] "+quotes" ] == -1 } { return }
	if { [ lsearch -exact [ channel info $chan ] "+oponlyquotes" ] != -1 && ! [ isop $nick $chan ] } { return }
	if { $text == "" } {
		set text "*"
	}
	set q [ quotes:quote $nick $host $chan $text ]
	if { $q != -1} {
		putserv "PRIVMSG $chan :\002Quote:\002 $q"
	}
}

proc quotes:pub:link { nick host handle chan text } {
	if { [ lsearch -exact [ channel info $chan ] "+quotes" ] == -1 } { return }
	if { [ lsearch -exact $::quotes(exclude) $chan ] != -1 } { return }
	putserv "PRIVMSG $chan :\002Quotelink:\002 $::quotes(link)[ string range $chan 1 end ]"
}

proc quotes:pub:stats { nick host handle chan text } {
	if { [ lsearch -exact [ channel info $chan ] "+quotes" ] == -1 } { return }
	if { [ lsearch -exact [ channel info $chan ] "+oponlyquotes" ] != -1 && ! [ isop $nick $chan ] } { return }
	if { $text == "" } {
		set text "*"
	}
	set q [ quotes:stats $nick $host $chan $text ]
	if { $q == 1 } {
		putserv "PRIVMSG $chan :\002Quotestats:\002 $q quote corrispondente a $text"
	} else {
		putserv "PRIVMSG $chan :\002Quotestats:\002 $q quotes corrispondenti a $text"
	}
}

proc quotes:pub:addglobal { nick host handle chan text } {
	if { $text != "" } {
		foreach chan [ channels ] {
			if { [ lsearch -exact [ channel info $chan ] "+globalquotes" ] != -1 } {
				quotes:add $nick $host $chan $text
			}
		}
		putserv "NOTICE $nick :Quote Globale Aggiunta !"
	} else {
		putserv "NOTICE $nick :\002Utilizzo:\002 !addglobalquote <testo>"
	}
}

proc quotes:pub:delglobal { nick host handle chan text } {
	if { $text != "" } {
		foreach chan [ channels ] {
			if { [ lsearch -exact [ channel info $chan ] "+globalquotes" ] != -1 } {
				quotes:del $nick $host $chan $text
			}
		}
		putserv "NOTICE $nick :Quote Globale Eliminata !"
	} else {
		putserv "NOTICE $nick :\002Utilizzo:\002 !delglobalquote <testo>"
	}
}

###

proc quotes:add { nick host chan text } {
	global quotes
	set f [ open "$quotes(dir)/[ string range $chan 1 end ].txt" "a" ]
	puts $f "$text"
	close $f

	## UPLOAD ##
	#if { [ lsearch -exact $::quotes(exclude) $chan ] == -1 } {
	#	exec data/quote/scripts/send.sh "[ string range $chan 1 end ]"
	#}

	set log [ open "$quotes(dir)/quotes.log" "a" ]
	puts $log "[strftime %A,\ %d\ %B\ %Y\ @\ %H:%M:%S]\tADD\t$nick ($host / $chan): $text"
	close $log
}

proc quotes:del { nick host chan text } {
	global quotes
	set f [ open "$quotes(dir)/[ string range $chan 1 end ].txt" "r" ]
	set tmp [ open "$quotes(dir)/[ string range $chan 1 end ].tmp" "w" ]
	while { ! [ eof $f ] } {
		set line [ gets $f ]
		if { ! [ string match [string tolower $text] [string tolower $line] ] && $line != "" } {
			puts $tmp "$line"
		}
	}
	close $tmp
	close $f
	file rename -force "$quotes(dir)/[ string range $chan 1 end ].tmp" "$quotes(dir)/[ string range $chan 1 end ].txt"

	## UPLOAD ##
	#if { [ lsearch -exact $::quotes(exclude) $chan ] == -1 } {
	#	exec data/quote/scripts/send.sh "[ string range $chan 1 end ]"
	#}

	set log [ open "$quotes(dir)/quotes.log" "a" ]
	puts $log "[strftime %A,\ %d\ %B\ %Y\ @\ %H:%M:%S]\tDEL\t$nick ($host / $chan): $text"
	close $log
}

proc quotes:stats { nick host chan text } {
	global quotes
	set count 0
	set f [ open "$quotes(dir)/[ string range $chan 1 end ].txt" "r" ]
	while { ! [ eof $f ] } {
		set line [ gets $f ]
		if { [ string match [string tolower $text] [string tolower $line] ] } {
			incr count
		}
	}
	close $f
	return $count
}

proc quotes:quote { nick host chan text } {
	global quotes
	set qs { }
	set f [ open "$quotes(dir)/[ string range $chan 1 end ].txt" "r" ]
	while { ! [ eof $f ] } {
		set line [ gets $f ]
		if { [ string match [ string tolower $text ] [ string tolower $line ] ] } {
			if { $line != "" } {
				lappend qs "$line"
			}
		}
	}
	close $f
	if { [ llength $qs ] == 0 } {
		return -1
	}
	return [ lindex $qs [ rand [ llength $qs ] ] ]
}

# Tuesday, 01 February 2005 @ 02:49:59	ADD	SimosNap (simos@simosnap.net / #bot): <Quote> (bot@free.shell.simosnap.com) has joined #bot
proc quotes:restore { chan } {
	global quotes
	set i 0
	set f [ open "$quotes(dir)/[ string range $chan 1 end ].txt" "w" ]
	set log [ open "$quotes(dir)/quotes.log" "r" ]
	while { ! [ eof $log ] } {
		set line [ gets $log ]
		if { [ regexp -nocase -- ".+\\tADD\\t.+/ $chan\\): (.+)" $line all quote ] } {
			incr i
			puts $f "$quote"
		}
	}
	close $log
	close $f

	## UPLOAD ##
	#if { [ lsearch -exact $::quotes(exclude) $chan ] == -1 } {
	#	exec data/quote/scripts/send.sh "[ string range $chan 1 end ]"
	#}

	return $i
}
### END PROCS ###

### INITIAL ###
putlog "\037QUOTES\037 \002::\002 \037LOADED\037 version 1.0 by lnx85"

